;***********************************************************************

(define (script-fu-cf-animationen-quader-02
             p-bild
             p-ebene-0
             p-ebene-1
             p-ebene-2
             p-ebene-3
             p-ebene-4
             p-ebene-5
             p-groesse
             p-richtung
             p-weite
             p-ebenen-anzahl
             p-tranzparenz
             p-standzeit
         )

   (let*
     (
       (ebene-vg 0)
       (ebene-hg 0)
       (ebene-s1 0)
       (ebene-s2 0)
       (ebene-s3 0)
       (ebene-s4 0)
       (c0 '(0 0 0))
       (g0 (/ p-groesse 100))
       (new-image (car (gimp-image-new (car (gimp-image-width p-bild)) (car (gimp-image-height p-bild)) (car (gimp-image-base-type p-bild)))))

       (vs  (car (gimp-layer-new-from-drawable p-ebene-1 new-image)))
       (hs  (car (gimp-layer-new-from-drawable p-ebene-3 new-image)))
       (os  (if (= p-richtung 3) (car (gimp-layer-new-from-drawable p-ebene-4 new-image))
                                 (car (gimp-layer-new-from-drawable p-ebene-2 new-image))))
       (us  (if (= p-richtung 3) (car (gimp-layer-new-from-drawable p-ebene-2 new-image))
                                 (car (gimp-layer-new-from-drawable p-ebene-4 new-image))))
       (ls  (if (= p-richtung 1) (car (gimp-layer-new-from-drawable p-ebene-4 new-image))
                                 (car (gimp-layer-new-from-drawable p-ebene-2 new-image))))
       (rs  (if (= p-richtung 1) (car (gimp-layer-new-from-drawable p-ebene-2 new-image))
                                 (car (gimp-layer-new-from-drawable p-ebene-4 new-image))))
       (hg  (car (gimp-layer-new-from-drawable p-ebene-5 new-image)))

       (i 0)
       (wx 0)
       (wy 0)
       (wz 0)
       (w0 	(cond ((= (modulo p-weite 4) 0) (/ 360 p-ebenen-anzahl) )              
									((= (modulo p-weite 4) 1) (/ 270 p-ebenen-anzahl) )
									((= (modulo p-weite 4) 2) (/ 180 p-ebenen-anzahl) )
									((= (modulo p-weite 4) 3) (/ 90  p-ebenen-anzahl) )
						)
			 )
       (steps p-ebenen-anzahl)
     )

    (if (= (modulo p-richtung 2) 1)
      (set! w0 (* w0 -1))
    )

    (if (> p-weite 3)
      (set! steps (+ steps 1))
    )

   (if (> p-richtung 1)
     (begin
       (set! ebene-s3   (car (gimp-layer-copy hs FALSE)))
       (gimp-image-add-layer new-image ebene-s3  0)
       (gimp-layer-resize-to-image-size ebene-s3)
       (set! hs (car(gimp-drawable-transform-rotate-simple ebene-s3 1 TRUE 0 0 FALSE)))
       (set! hs  (car (gimp-layer-new-from-drawable hs new-image)))
			 (gimp-image-remove-layer new-image ebene-s3)
     )
   )

     (while (< i steps)
       (begin
         (set! ebene-vg   (car (gimp-layer-copy vs new-image)))
         (gimp-image-add-layer new-image ebene-vg  0)

  (plug-in-map-object
                   1 new-image ebene-vg                   
									 2 0.5 0.5 
                   3.0 0.5 0.5         
                   0 1.0 0.0 0.0 0.0 1.0 0.0 
                   wx wy wz              
                   0               
                   '(255 255 255)  
                   -0.5 -0.5 2 -1.0 -1.0 1.0             
                   0.3 1.0 0.5 0.5 27.0            
                   TRUE FALSE FALSE TRUE 
                   0.0             
                   g0 g0 g0            
                   0 
                   vs hs os us ls rs         
                   -1 -1 
     )

					(if (and (> p-weite 3) (= i steps))
						(begin
						
						)
					)

					(cond ((< p-richtung 2) (set! wy (+ wy w0) ) )
               ((< p-richtung 4) (set! wx (+ wx w0) ) )
               ((< p-richtung 6) (set! wz (+ wz w0) ) )
               )

         (if (= p-tranzparenz FALSE)
           (begin
             (set! ebene-hg   (car (gimp-layer-copy hg new-image)))
               (gimp-image-add-layer new-image ebene-hg 1)
             (set! ebene-vg (car (gimp-image-merge-down new-image ebene-vg 1)))
           )
         )

         (set! i (+ i 1))
         (gimp-drawable-set-name ebene-vg (string-append "Ebene "
         (number->string i) " (" (number->string p-standzeit) "ms)
(replace)"))

       )

     )

     (gimp-display-new new-image)
     (gimp-displays-flush)

   )
)

(script-fu-register
   "script-fu-cf-animationen-quader-02"
   "CFU Quader - Animation - Light"
   "Einfache Animation eines Quaders"
   "CF"
   "CF"
   "2012"
   "RGB*"
   SF-IMAGE "Bild:" 0
   SF-DRAWABLE "Ebene" 0
   SF-DRAWABLE "Seite 1" 0
   SF-DRAWABLE "Seite 2" 0
   SF-DRAWABLE "Seite 3" 0
   SF-DRAWABLE "Seite 4" 0
   SF-DRAWABLE "Hintergrund:" 0
   SF-ADJUSTMENT "Größe in %"  '(50 1 100 1 10 0 0)
   SF-OPTION     "Drehrichtung" '(
                                   "Nach Links"
                                   "Nach Rechts"
                                   "Nach Unten"
                                   "Nach Oben"
                                 )
   SF-OPTION     "Drehrweite" '(
                                 "Ganze Drehzung ohne Endebild"
                                 "Dreiviertel Drehung ohne Endebild"
                                 "Halbe Drehung ohne Endebild"
                                 "Viertel Drehung ohne Endebild"
                                 "Ganze Drehzung mit Endebild"
                                 "Dreiviertel Drehung mit Endebild"
                                 "Halbe Drehung mit Endebild"
                                 "Viertel Drehung mit Endebild"
                               )
   SF-ADJUSTMENT "Anzahl der Ebenen" '(44 4 720 1 10 0 0)
   SF-TOGGLE     "Transpatente Ani " FALSE
   SF-ADJUSTMENT "Standzeit in ms" '(50 1 1000 1 10 0 0)
)

(script-fu-menu-register "script-fu-cf-animationen-quader-02" 
"<Image>/CFU/Animationen")
;***********************************************************************




